校省选赛第一场C题解Practice

2024-05-28 19:38

本文主要是介绍校省选赛第一场C题解Practice,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

比赛时间只有两个小时,我没有选做这题,因为当时看样例也看不懂,比较烦恼。

后来发现,该题对输入输出要求很低。远远没有昨天我在做的A题的麻烦,赛后认真看了一下就明白了,写了一下,一次就AC了,没问题,真心有点后悔。

来先看题目:




C. Practice
t ime limit per test
1 second
memory limit per test
256 megabytes
input
input.txt
output
output.txt


Little time is left before Berland annual football championship. Therefore the coach of team "Losewille Rangers" decided to resume the practice, that were indefinitely interrupted for uncertain reasons. Overall there are n players in "Losewille Rangers". Each player on the team has a number — a unique integer from 1 to n. To prepare for the championship, the coach Mr. Floppe decided to spend some number of practices.

Mr. Floppe spent some long nights of his holiday planning how to conduct the practices. He came to a very complex practice system. Each practice consists of one game, all n players of the team take part in the game. The players are sorted into two teams in some way. In this case, the teams may have different numbers of players, but each team must have at least one player.

The coach wants to be sure that after the series of the practice sessions each pair of players had at least one practice, when they played in different teams. As the players' energy is limited, the coach wants to achieve the goal in the least number of practices.

Help him to schedule the practices.
Input

A single input line contains integer n (2 ≤ n ≤ 1000).
Output

In the first line print m — the minimum number of practices the coach will have to schedule. Then print the descriptions of the practices in m lines.

In the i-th of those lines print fi — the number of players in the first team during the i-th practice (1 ≤ fi < n), and fi numbers from 1 to n — the numbers of players in the first team. The rest of the players will play in the second team during this practice. Separate numbers on a line with spaces. Print the numbers of the players in any order. If there are multiple optimal solutions, print any of them.
Sample test(s)
Input

2

Output

1
1 1

Input

3

Output

2
2 1 2
1 1

如果你跟我一样,看不下题目的话,可以听我解释一下:
有一支球队,有n个人,现在教练要分成两队来练习,队伍必须要有人(不然怎么踢~?)。
问最小组织多少场练习,能够让每个队伍里面的人都有与队友对战过至少一次。
输入为人数n
输出第一行为至少练习场数k。
接下来k行是,第一队伍的人数,以及球员号码,如果有多种情况,随意输出一种。
比如 3
那么至少需要2场
                  第一场               第二场
一队          1    2                   1  3
二队          3                          2
这么我们的输出就是
2
2 1 2
2 1 3
一开始看这题目,我以为是组合数学的东西,后来模拟了一下,有点像二分,当n=2^p,这个情况很容易想到,比如
1 2 3 4 5 6 7 8 个球员
我们需要进行3场球赛
1 2 3 4
5 6 7 8

5 6 3 4
1 2 7 8

1 6 7 4
5 2 3 8
做法就是:第一场1 ~4 为一队,剩下的为二队
第二场为一队前2个与二队的前2个交换
第三场为一队每两个人中的第一个人与二队的对应交换。
推广到2^p次方就是
第一场为 1~ 2^(p-1)为一队,剩下的为二队
第二场为一队前2^(p-2)个人与二队的对应交换
第三场为一队每2^(p-2)个人前2^(p-3)个人与二队的对应交换
………
第  i 场为一队每2^(p-i+1)个人前 2^(p-i)个人与二队的对应交换
直到i=p为止

那么这个策略是最优的吗?
我们可以这么想,当n=2时,p=1,显然是最优,当n=4时,p=2,第一场
1 2
3 4
之后需要的是1 2对战, 3 4对战,当1 2对战时候,3 4也会对战,这个操作是对称的。显然此时也是正确的
那么 1 2 3 4  后
         5 6 7 8
可以化成1 2 3 4对战,同时对应的5 6 7 8也会对战(对称性)。那么就化成1 2 3 4的情况了。
即个策略推广下去,也是最优的。
我们之所以选择前面的往下调,是为了写起来方便,效果是一样的,可以想象一下。
但是当n!=2^p时候,怎么办呢?
我的想法是加上“替补",当然这是我的说法啦,就是填补0,使得填补后的 n=2^p,这样,当填补后满足了,正常的也会满足(这是显然的)。但是,会不会有满足“替补”带来的多余的操作次数呢?(细心的人会这么想)
其实仔细一想,无需担心。我们这样考虑,n必然会被有不等式,2^p0<n<2^(p0+1),我们的策略始终有一个位置的人不动的在1~2^(p0-1)个位置中总有一个不是不动的,在我的策略中就是第2^(p0-1)位置是不动的
比如
1 2 3 4
5 6 7 8 9

5 6 3 4
1 2 7 8 9

1 6 7 4
5 2 3 8 9
这样一来,9号始终不与8对战,同理可以推理更多情况,这样看来,需要的场数需要大于p0,而p0-1必然满足。证毕。
所以我们最后的得到的结果就是 ceil(log2(n))场比赛,当n不为2^p数,填补0,之后按照上述策略,在输出的时候忽略0.
以下是我的代码,一次AC,莫大的鼓励啊!(尽管是赛后了~)代码不当之处,欢迎大家的建议、指导!
明晚第二场!为自己加油!

#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<vector>
using namespace std;
vector<int> v,v2;void swap_v(int bg,int len)
{int i;for(i=0; i<len/2; i++){v[bg+i]=v[bg+i]^v2[bg+i]^(v2[bg+i]=v[bg+i]); //位运算交换}
}int main()
{freopen("input.txt","r",stdin);freopen("output.txt","w",stdout);int n,i,j;while(cin>>n){int cnt=ceil(log(n)/log(2));;cout<<cnt<<endl;int siz  =1<<(cnt-1) ;//siz为填补后的人数一半v.clear();v2.clear();v.resize(siz+1);v2.resize(siz+1);for(i=1; i<=siz; i++){v[i]=i;          //初始化}for(i=1; i+siz<=n; i++){v2[i]=i+siz;}int len=siz;  //len为跨距for(; len!=0; len>>=1){cnt=0;   //其实严格来说要用第二个变量来记载一队的人数,但是“废物利用嘛……”for(j=1; j<=siz; j++){if(v[j]){cnt++;}}cout<<cnt;  //输出一队人数for(j=1; j<=siz; j++){if(v[j]){cout<<" "<<v[j];   //不是替补0就输出}}cout<<endl;for(j=1; j<=siz&&len!=1; j+=len){swap_v(j,len);           //每len个人交换前len/2个人}}}fclose(stdin);fclose(stdout);return 0;}


这篇关于校省选赛第一场C题解Practice的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1011505

相关文章

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

C - Word Ladder题解

C - Word Ladder 题解 解题思路: 先输入两个字符串S 和t 然后在S和T中寻找有多少个字符不同的个数(也就是需要变换多少次) 开始替换时: tips: 字符串下标以0开始 我们定义两个变量a和b,用于记录当前遍历到的字符 首先是判断:如果这时a已经==b了,那么就跳过,不用管; 如果a大于b的话:那么我们就让s中的第i项替换成b,接着就直接输出S就行了。 这样

【秋招笔试】9.07米哈游秋招改编题-三语言题解

🍭 大家好这里是 春秋招笔试突围,一起备战大厂笔试 💻 ACM金牌团队🏅️ | 多次AK大厂笔试 | 大厂实习经历 ✨ 本系列打算持续跟新 春秋招笔试题 👏 感谢大家的订阅➕ 和 喜欢💗 和 手里的小花花🌸 ✨ 笔试合集传送们 -> 🧷春秋招笔试合集 🍒 本专栏已收集 100+ 套笔试题,笔试真题 会在第一时间跟新 🍄 题面描述等均已改编,如果和你笔试题看到的题面描述

LeetCode 第414场周赛个人题解

目录 Q1. 将日期转换为二进制表示 原题链接 思路分析 AC代码 Q2. 范围内整数的最大得分 原题链接 思路分析 AC代码 Q3. 到达数组末尾的最大得分 原题链接 思路分析 AC代码 Q4. 吃掉所有兵需要的最多移动次数 原题链接 思路分析 AC代码 Q1. 将日期转换为二进制表示 原题链接 Q1. 将日期转换为二进制表示 思路分析

牛客小白月赛100部分题解

比赛地址:牛客小白月赛100_ACM/NOI/CSP/CCPC/ICPC算法编程高难度练习赛_牛客竞赛OJ A.ACM中的A题 #include<bits/stdc++.h>using namespace std;#define ll long long#define ull = unsigned long longvoid solve() {ll a,b,c;cin>>a>>b>

P2858 [USACO06FEB] Treats for the Cows G/S 题解

P2858 题意 给一个数组。每天把最左或者最右的东西卖掉,第 i i i个东西,第 d a y day day天卖出的价格是 a [ i ] ∗ d a y a[i]*day a[i]∗day。 记忆化搜索 void dfs(int l,int r,int day,ll sum){if(v[l][r]>=sum)return;v[l][r]=sum;if(l>r)//这就是dp答案{

【C++题解】1272. 郭远摘苹果

欢迎关注本专栏《C++从零基础到信奥赛入门级(CSP-J)》 问题:1272. 郭远摘苹果 类型:二维数组 题目描述: 郭远有一天走到了一片苹果林,里面每颗树上都结有不同数目的苹果,郭远身上只能拿同一棵树上的苹果,他每到一棵果树前都会把自己身上的苹果扔掉并摘下他所在树上的苹果并带走(假设郭远会走过每一棵苹果树),问在郭远摘苹果的整个过程中,他身上携带的最多苹果数与最小苹果数的差是多少?

【最新华为OD机试E卷-支持在线评测】机器人活动区域(100分)多语言题解-(Python/C/JavaScript/Java/Cpp)

🍭 大家好这里是春秋招笔试突围 ,一枚热爱算法的程序员 ✨ 本系列打算持续跟新华为OD-E/D卷的三语言AC题解 💻 ACM金牌🏅️团队| 多次AK大厂笔试 | 编程一对一辅导 👏 感谢大家的订阅➕ 和 喜欢💗 🍿 最新华为OD机试D卷目录,全、新、准,题目覆盖率达 95% 以上,支持题目在线评测,专栏文章质量平均 94 分 最新华为OD机试目录: https://blog.

2023 CCPC(秦皇岛)现场(第二届环球杯.第 2 阶段:秦皇岛)部分题解

所有题目链接:Dashboard - The 2023 CCPC (Qinhuangdao) Onsite (The 2nd Universal Cup. Stage 9: Qinhuangdao) - Codeforces 中文题面: contest-37054-zh.pdf (codeforces.com) G. Path 链接: Problem - G - Codeforces